﻿abstract record Person {
	public string? FirstName { get; set; }
	public string? LastName { get; set; }
}

record Customer : Person {
	public int TotalOrders { get; set; }
}

record Employee : Person {
	public decimal Salary { get; set; }
	public DateOnly DateHired { get; set; }
}

record Helper : Person {
	public bool Qualified { get; set; }
}

class Program {
	static void Main(string[] args) {

		Person p1;

		p1 = new Employee { FirstName = "Jiri", LastName = "Vesely", Salary = 1000, DateHired = DateOnly.FromDateTime(DateTime.Today) };

		if (p1 is Employee e) {
			Console.WriteLine(e.Salary);
		}

		if (!(p1 is Customer)) {
			Console.WriteLine("Not a customer.");
		}
	}
}
